<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:UML="org.omg.xmi.namespace.UML">
  <xsl:output method="xml" encoding="UTF-8" />

<!--

Open Source Initiative OSI - Common Public License Version 1.0

THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC 
LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM 
CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

1. DEFINITIONS 

"Contribution" means:

  a) in the case of the initial Contributor, the initial code and documentation 
  distributed under this Agreement, and
 
  b) in the case of each subsequent Contributor:

  i) changes to the Program, and

  ii) additions to the Program;

  where such changes and/or additions to the Program originate from and are 
  distributed by that particular Contributor. A Contribution 'originates' from a 
  Contributor if it was added to the Program by such Contributor itself or 
  anyone acting on such Contributor's behalf. Contributions do not include 
  additions to the Program which: (i) are separate modules of software 
  distributed in conjunction with the Program under their own license agreement, 
  and (ii) are not derivative works of the Program.

"Contributor" means any person or entity that distributes the Program. 

"Licensed Patents " mean patent claims licensable by a Contributor which are 
necessarily infringed by the use or sale of its Contribution alone or when 
combined with the Program.

"Program" means the Contributions distributed in accordance with this Agreement. 

"Recipient" means anyone who receives the Program under this Agreement, 
including all Contributors. 

2. GRANT OF RIGHTS

  a) Subject to the terms of this Agreement, each Contributor hereby grants 
  Recipient a non-exclusive, worldwide, royalty-free copyright license to 
  reproduce, prepare derivative works of, publicly display, publicly perform, 
  distribute and sublicense the Contribution of such Contributor, if any, and 
  such derivative works, in source code and object code form.

  b) Subject to the terms of this Agreement, each Contributor hereby grants 
  Recipient a non-exclusive, worldwide, royalty-free patent license under 
  Licensed Patents to make, use, sell, offer to sell, import and otherwise 
  transfer the Contribution of such Contributor, if any, in source code and 
  object code form. This patent license shall apply to the combination of the 
  Contribution and the Program if, at the time the Contribution is added by the 
  Contributor, such addition of the Contribution causes such combination to be 
  covered by the Licensed Patents. The patent license shall not apply to any 
  other combinations which include the Contribution. No hardware per se is 
  licensed hereunder.

  c) Recipient understands that although each Contributor grants the licenses to 
  its Contributions set forth herein, no assurances are provided by any 
  Contributor that the Program does not infringe the patent or other 
  intellectual property rights of any other entity. Each Contributor disclaims 
  any liability to Recipient for claims brought by any other entity based on 
  infringement of intellectual property rights or otherwise. As a condition to 
  exercising the rights and licenses granted hereunder, each Recipient hereby 
  assumes sole responsibility to secure any other intellectual property rights 
  needed, if any. For example, if a third party patent license is required to 
  allow Recipient to distribute the Program, it is Recipient's responsibility to 
  acquire that license before distributing the Program.

  d) Each Contributor represents that to its knowledge it has sufficient 
  copyright rights in its Contribution, if any, to grant the copyright license 
  set forth in this Agreement.

3. REQUIREMENTS 

A Contributor may choose to distribute the Program in object code form under its 
own license agreement, provided that: 

  a) it complies with the terms and conditions of this Agreement; and

  b) its license agreement:

  i) effectively disclaims on behalf of all Contributors all warranties and 
  conditions, express and implied, including warranties or conditions of title 
  and non-infringement, and implied warranties or conditions of merchantability 
  and fitness for a particular purpose; 

  ii) effectively excludes on behalf of all Contributors all liability for 
  damages, including direct, indirect, special, incidental and consequential 
  damages, such as lost profits; 

  iii) states that any provisions which differ from this Agreement are offered 
  by that Contributor alone and not by any other party; and 

  iv) states that source code for the Program is available from such 
  Contributor, and informs licensees how to obtain it in a reasonable manner on 
  or through a medium customarily used for software exchange. 

When the Program is made available in source code form:

  a) it must be made available under this Agreement; and

  b) a copy of this Agreement must be included with each copy of the Program. 

Contributors may not remove or alter any copyright notices contained within the 
Program.

Each Contributor must identify itself as the originator of its Contribution, if 
any, in a manner that reasonably allows subsequent Recipients to identify the 
originator of the Contribution. 

4. COMMERCIAL DISTRIBUTION 

Commercial distributors of software may accept certain responsibilities with 
respect to end users, business partners and the like. While this license is 
intended to facilitate the commercial use of the Program, the Contributor who 
includes the Program in a commercial product offering should do so in a manner 
which does not create potential liability for other Contributors. Therefore, if 
a Contributor includes the Program in a commercial product offering, such 
Contributor ("Commercial Contributor") hereby agrees to defend and indemnify 
every other Contributor ("Indemnified Contributor") against any losses, damages 
and costs (collectively "Losses") arising from claims, lawsuits and other legal 
actions brought by a third party against the Indemnified Contributor to the 
extent caused by the acts or omissions of such Commercial Contributor in 
connection with its distribution of the Program in a commercial product 
offering. The obligations in this section do not apply to any claims or Losses 
relating to any actual or alleged intellectual property infringement. In order 
to qualify, an Indemnified Contributor must: a) promptly notify the Commercial 
Contributor in writing of such claim, and b) allow the Commercial Contributor to 
control, and cooperate with the Commercial Contributor in, the defense and any 
related settlement negotiations. The Indemnified Contributor may participate in 
any such claim at its own expense. 

For example, a Contributor might include the Program in a commercial product 
offering, Product X. That Contributor is then a Commercial Contributor. If that 
Commercial Contributor then makes performance claims, or offers warranties 
related to Product X, those performance claims and warranties are such 
Commercial Contributor's responsibility alone. Under this section, the 
Commercial Contributor would have to defend claims against the other 
Contributors related to those performance claims and warranties, and if a court 
requires any other Contributor to pay any damages as a result, the Commercial 
Contributor must pay those damages. 

5. NO WARRANTY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN 
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR 
IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, 
NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each 
Recipient is solely responsible for determining the appropriateness of using and 
distributing the Program and assumes all risks associated with its exercise of 
rights under this Agreement, including but not limited to the risks and costs of 
program errors, compliance with applicable laws, damage to or loss of data, 
programs or equipment, and unavailability or interruption of operations.
 
6. DISCLAIMER OF LIABILITY 

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY 
CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST 
PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS 
GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

7. GENERAL

If any provision of this Agreement is invalid or unenforceable under applicable 
law, it shall not affect the validity or enforceability of the remainder of the 
terms of this Agreement, and without further action by the parties hereto, such 
provision shall be reformed to the minimum extent necessary to make such 
provision valid and enforceable. 

If Recipient institutes patent litigation against a Contributor with respect to 
a patent applicable to software (including a cross-claim or counterclaim in a 
lawsuit), then any patent licenses granted by that Contributor to such Recipient 
under this Agreement shall terminate as of the date such litigation is filed. In 
addition, if Recipient institutes patent litigation against any entity 
(including a cross-claim or counterclaim in a lawsuit) alleging that the Program 
itself (excluding combinations of the Program with other software or hardware) 
infringes such Recipient's patent(s), then such Recipient's rights granted under 
Section 2(b) shall terminate as of the date such litigation is filed.

All Recipient's rights under this Agreement shall terminate if it fails to 
comply with any of the material terms or conditions of this Agreement and does 
not cure such failure in a reasonable period of time after becoming aware of 
such noncompliance. If all Recipient's rights under this Agreement terminate, 
Recipient agrees to cease use and distribution of the Program as soon as 
reasonably practicable. However, Recipient's obligations under this Agreement 
and any licenses granted by Recipient relating to the Program shall continue and 
survive. 

Everyone is permitted to copy and distribute copies of this Agreement, but in 
order to avoid inconsistency the Agreement is copyrighted and may only be 
modified in the following manner. The Agreement Steward reserves the right to 
publish new versions (including revisions) of this Agreement from time to time. 
No one other than the Agreement Steward has the right to modify this Agreement. 
IBM is the initial Agreement Steward. IBM may assign the responsibility to serve 
as the Agreement Steward to a suitable separate entity. Each new version of the 
Agreement will be given a distinguishing version number. The Program (including 
Contributions) may always be distributed subject to the version of the Agreement 
under which it was received. In addition, after a new version of the Agreement 
is published, Contributor may elect to distribute the Program (including its 
Contributions) under the new version. Except as expressly stated in Sections 
2(a) and 2(b) above, Recipient receives no rights or licenses to the 
intellectual property of any Contributor under this Agreement, whether 
expressly, by implication, estoppel or otherwise. All rights in the Program not 
expressly granted under this Agreement are reserved. 

This Agreement is governed by the laws of the State of New York and the 
intellectual property laws of the United States of America. No party to this 
Agreement will bring a legal action under this Agreement more than one year 
after the cause of action arose. Each party waives its rights to a jury trial in 
any resulting litigation.

-->


<!-- June xx, 2003 Release 0.1

     This stylesheet reads an XML file containing an EXPRESS 1 Schema and generates the equivalent UML 1.4 XMI 1.2 file.
     The XMI files tested the native format used by the free tool Poseidon Community Edition. This stylesheet has not been
     tested against any other XMI files. The XMI files do validate using the UML 1.4 DTD.

      Currently only the following are supported:

      EXPRESS schema -> UML Package within a UML Model named "data specification view"
      EXPRESS entity -> UML Class
      EXPRESS ABSTRACT SUPERTYPE -> UML Abstract Class, no other SUPERTYPE constraint created
      EXPRESS SUBTYPE OF -> UML Generalization, Multiple inheritance is supported
      EXPRESS SET explicit attribute -> UML Association between UML Classes, UML Multiplicity created
      EXPRESS single valued explicit attribute -> UML Attribute, OPTIONAL supported
      EXPRESS STRING simple type -> UML Class named string
      EXPRESS BINARY simple type -> UML Class named binary
      EXPRESS BOOLEAN simple type -> UML Class named boolean
      EXPRESS REAL simple type -> UML Class named real
      EXPRESS INTEGER simple type -> UML Class named integer
      EXPRESS NUMBER simple type -> UML Class named real

-->


  <xsl:template match="/">

    <!-- Add the required XMI stuff (XMI added this way due to ns problem) -->
    <XMI xmlns="UML" xmi.version="1.2">

      <xsl:element name="XMI.header">
        <xsl:element name="XMI.documentation">
          <xsl:element name="XMI.exporter">EXPRESS to UML 1.4 XMI 1.1 Stylesheet</xsl:element>
          <xsl:element name="XMI.exporterVersion">0.1</xsl:element>
        </xsl:element>
      </xsl:element>

      <xsl:element name="XMI.content">
        <xsl:element name="UML:Model">
          <xsl:attribute name="name">Data specification view</xsl:attribute>
          <xsl:attribute name="xmi.id">a1</xsl:attribute>
          <xsl:attribute name="isAbstract">false</xsl:attribute>
          <xsl:attribute name="isSpecification">false</xsl:attribute>
          <xsl:attribute name="isRoot">false</xsl:attribute>
          <xsl:attribute name="isLeaf">false</xsl:attribute>

          <xsl:element name="UML:Namespace.ownedElement">

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">string</xsl:attribute>
              <xsl:attribute name="xmi.id">string</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">integer</xsl:attribute>
              <xsl:attribute name="xmi.id">integer</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">real</xsl:attribute>
              <xsl:attribute name="xmi.id">real</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">boolean</xsl:attribute>
              <xsl:attribute name="xmi.id">boolean</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">logical</xsl:attribute>
              <xsl:attribute name="xmi.id">logical</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:element name="UML:Class">
              <xsl:attribute name="name">binary</xsl:attribute>
              <xsl:attribute name="xmi.id">binary</xsl:attribute>
              <xsl:attribute name="isAbstract">false</xsl:attribute>
              <xsl:attribute name="isSpecification">false</xsl:attribute>
              <xsl:attribute name="isRoot">false</xsl:attribute>
              <xsl:attribute name="isLeaf">false</xsl:attribute>
              <xsl:attribute name="isActive">false</xsl:attribute>
              <xsl:attribute name="visibility">public</xsl:attribute>
            </xsl:element>

            <xsl:for-each select="//express/schema">

              <xsl:element name="UML:Package">
                <xsl:attribute name="name"><xsl:value-of select="./@name" /></xsl:attribute>
                <xsl:attribute name="xmi.id">a2</xsl:attribute>
                <xsl:attribute name="isAbstract">false</xsl:attribute>
                <xsl:attribute name="isSpecification">false</xsl:attribute>
                <xsl:attribute name="isRoot">false</xsl:attribute>
                <xsl:attribute name="isLeaf">false</xsl:attribute>

                <xsl:element name="UML:Namespace.ownedElement">

                  <xsl:for-each select="./node()">

                    <xsl:choose>
                      <xsl:when test="local-name() = 'entity'">

                        <!-- Add a generalization for each supertype at same level as UML as Class -->
                        <xsl:for-each select="./@supertypes">

                          <xsl:call-template name="gen_supertypes">
                            <xsl:with-param name="nmtokens" select="../@supertypes"/>
                            <xsl:with-param name="child" select="../@name"/>
                          </xsl:call-template>

                        </xsl:for-each>


                        <!-- Add an association for each entity valued attributes at same level in UML as Class -->
                        <xsl:for-each select="./explicit/typename">

                          <xsl:element name="UML:Association">
                            <xsl:attribute name="xmi.id">assoc<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>
                            <xsl:attribute name="name"><xsl:value-of select="../@name" /></xsl:attribute>
                            <xsl:attribute name="isAbstract">false</xsl:attribute>
                            <xsl:attribute name="isSpecification">false</xsl:attribute>
                            <xsl:attribute name="isRoot">false</xsl:attribute>
                            <xsl:attribute name="isLeaf">false</xsl:attribute>

                            <xsl:element name="UML:Association.connection">

                              <xsl:element name="UML:AssociationEnd">
                                <xsl:attribute name="xmi.id">ae1<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>
                                <xsl:attribute name="isSpecification">false</xsl:attribute>
                                <xsl:attribute name="visibility">public</xsl:attribute>
                                <xsl:attribute name="isNavigable">true</xsl:attribute>
                                <xsl:attribute name="ordering">unordered</xsl:attribute>
                                <xsl:attribute name="aggregation">none</xsl:attribute>
                                <xsl:attribute name="changeability">changeable</xsl:attribute>

                                <xsl:element name="UML:AssociationEnd.multiplicity">

                                  <xsl:element name="UML:Multiplicity">
                                    <xsl:attribute name="xmi.id">aem1<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>

                                    <xsl:element name="UML:Multiplicity.range">

                                      <xsl:element name="UML:MultiplicityRange">
                                        <xsl:attribute name="xmi.id">aemr1<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>
                                        <xsl:attribute name="lower">0</xsl:attribute>
                                        <xsl:attribute name="upper">-1</xsl:attribute>
                                      </xsl:element>
                                    </xsl:element>
                                  </xsl:element>
                                </xsl:element>

                                <xsl:element name="UML:AssociationEnd.participant">

                                  <xsl:element name="UML:Class">
                                    <xsl:attribute name="xmi.idref"><xsl:value-of select="../../@name" /></xsl:attribute>
                                  </xsl:element>
                                </xsl:element>
                              </xsl:element>

                              <xsl:element name="UML:AssociationEnd">
                                <xsl:attribute name="xmi.id">ae2<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>
                                <xsl:attribute name="name"><xsl:value-of select="../@name" /></xsl:attribute>
                                <xsl:attribute name="isSpecification">false</xsl:attribute>
                                <xsl:attribute name="visibility">public</xsl:attribute>
                                <xsl:attribute name="isNavigable">true</xsl:attribute>
                                <xsl:attribute name="ordering">unordered</xsl:attribute>
                                <xsl:attribute name="aggregation">none</xsl:attribute>
                                <xsl:attribute name="changeability">changeable</xsl:attribute>

                                <xsl:element name="UML:AssociationEnd.participant">

                                  <xsl:element name="UML:Class">
                                    <xsl:attribute name="xmi.idref"><xsl:value-of select="./@name" /></xsl:attribute>
                                  </xsl:element>
                                </xsl:element>

                                <xsl:element name="UML:AssociationEnd.multiplicity">

                                  <xsl:element name="UML:Multiplicity">
                                    <xsl:attribute name="xmi.id">aem2<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>

                                    <xsl:element name="UML:Multiplicity.range">

                                      <xsl:element name="UML:MultiplicityRange">
                                        <xsl:attribute name="xmi.id">aemr2<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>

                                        <xsl:choose>
                                          <xsl:when test="../aggregate/@type='SET'">

                                            <xsl:choose>
                                              <xsl:when test="../aggregate/@lower">
                                                <xsl:attribute name="lower"><xsl:value-of select="../aggregate/@lower" /></xsl:attribute>
                                              </xsl:when>
                                              <xsl:otherwise>
                                                <xsl:attribute name="lower">0</xsl:attribute>
                                              </xsl:otherwise>
                                            </xsl:choose>

                                            <xsl:choose>
                                              <xsl:when test="../aggregate/@upper='?'">
                                                <xsl:attribute name="upper">-1</xsl:attribute>
                                              </xsl:when>
                                              <xsl:when test="../aggregate/@upper">
                                               <xsl:attribute name="upper"><xsl:value-of select="../aggregate/@upper" /></xsl:attribute>
                                              </xsl:when>
                                              <xsl:otherwise>
                                                <xsl:attribute name="upper">-1</xsl:attribute>
                                              </xsl:otherwise>
                                            </xsl:choose>

                                          </xsl:when>

                                          <xsl:otherwise>
                                            <xsl:attribute name="lower">1</xsl:attribute>
                                            <xsl:attribute name="upper">1</xsl:attribute>
                                          </xsl:otherwise>
                                        </xsl:choose>
                                      </xsl:element>
                                    </xsl:element>
                                  </xsl:element>
                                </xsl:element>
                              </xsl:element>
                            </xsl:element>
                          </xsl:element>
                        </xsl:for-each>

                        <!-- Add a class for each entity type -->
                        <xsl:element name="UML:Class">
                          <xsl:attribute name="name"><xsl:value-of select="./@name" /></xsl:attribute>
                          <xsl:attribute name="xmi.id"><xsl:value-of select="./@name" /></xsl:attribute>
                          <xsl:choose>
                            <xsl:when test="./@abstract.supertype = 'YES'" >
                              <xsl:attribute name="isAbstract">true</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                              <xsl:attribute name="isAbstract">false</xsl:attribute>
                            </xsl:otherwise>
                          </xsl:choose>
                          <xsl:attribute name="isSpecification">false</xsl:attribute>
                          <xsl:attribute name="isRoot">false</xsl:attribute>
                          <xsl:attribute name="isLeaf">false</xsl:attribute>
                          <xsl:attribute name="isActive">false</xsl:attribute>
                          <xsl:attribute name="visibility">public</xsl:attribute>

                       <!-- Add a generalizable element supertype within the Class -->
                        <xsl:for-each select="./@supertypes">


                          <xsl:element name="UML:GeneralizableElement.generalization">

                          <xsl:call-template name="ref_supertypes">
                            <xsl:with-param name="nmtokens" select="../@supertypes"/>
                            <xsl:with-param name="child" select="../@name"/>
                          </xsl:call-template>

                          </xsl:element>

                        </xsl:for-each>
                         


                          <!-- Add an attribute for each simple valued explicit -->
                          <xsl:for-each select="./explicit/builtintype">

                            <xsl:element name="UML:Classifier.feature">

                              <xsl:element name="UML:Attribute">
                                <xsl:attribute name="name"><xsl:value-of select="../@name" /></xsl:attribute>
                                <xsl:attribute name="xmi.id"><xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>
                                <xsl:attribute name="isSpecification">false</xsl:attribute>
                                <xsl:attribute name="visibility">public</xsl:attribute>

                                <xsl:element name="UML:StructuralFeature.type">

                                  <xsl:choose>
                                    <xsl:when test="./@type='STRING'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">string</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='INTEGER'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">integer</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='REAL'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">real</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='LOGICAL'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">logical</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='BOOLEAN'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">boolean</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='BINARY'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">binary</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:when test="./@type='NUMBER'">
                                      <xsl:element name="UML:Class">
                                        <xsl:attribute name="xmi.idref">real</xsl:attribute>
                                      </xsl:element>
                                    </xsl:when>

                                    <xsl:otherwise />
                                  </xsl:choose>
                                </xsl:element>

                                 <!-- Add multiplicity -->
                                <xsl:choose>

                                  <xsl:when test="../aggregate/@type='SET'">

                                    <xsl:element name="UML:StructuralFeature.multiplicity">

                                      <xsl:element name="UML:Multiplicity">
                                        <xsl:attribute name="xmi.id">m1<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>

                                        <xsl:element name="UML:Multiplicity.range">

                                          <xsl:element name="UML:MultiplicityRange">
                                            <xsl:attribute name="xmi.id">m2<xsl:value-of select="../../@name" /><xsl:value-of select="../@name" /></xsl:attribute>

                                            <xsl:choose>
                                              <xsl:when test="../aggregate/@lower">
                                                <xsl:attribute name="lower"><xsl:value-of select="../aggregate/@lower" /></xsl:attribute>
                                              </xsl:when>
                                              <xsl:otherwise>
                                                <xsl:attribute name="lower">0</xsl:attribute>
                                              </xsl:otherwise>
                                            </xsl:choose>

                                            <xsl:choose>
                                              <xsl:when test="../aggregate/@upper='?'">
                                                <xsl:attribute name="upper">-1</xsl:attribute>
                                              </xsl:when>
                                              <xsl:when test="../aggregate/@upper">
                                               <xsl:attribute name="upper"><xsl:value-of select="../aggregate/@upper" /></xsl:attribute>
                                              </xsl:when>
                                              <xsl:otherwise>
                                                <xsl:attribute name="upper">-1</xsl:attribute>
                                              </xsl:otherwise>
                                            </xsl:choose>

                                          </xsl:element>
                                        </xsl:element>
                                      </xsl:element>
                                    </xsl:element>
                                  </xsl:when>

                                  <xsl:otherwise />
                                </xsl:choose>
                              </xsl:element>
                            </xsl:element>
                          </xsl:for-each>
                        </xsl:element>
                      </xsl:when>

                      <xsl:otherwise />
                    </xsl:choose>
                  </xsl:for-each>
                </xsl:element>
              </xsl:element>
            </xsl:for-each>
          </xsl:element>
        </xsl:element>
      </xsl:element>
    </XMI>
  </xsl:template>


  <xsl:template name="gen_supertypes">
    <xsl:param name="nmtokens"/>
    <xsl:param name="child"/>

    <xsl:if test="string-length($nmtokens) > 0">

      <xsl:element name="UML:Generalization">

        <xsl:if test="string-length(substring-before($nmtokens, ' ')) > 0">
        <xsl:attribute name="xmi.id"><xsl:value-of select="substring-before($nmtokens, ' ')" /><xsl:value-of select="$child" /></xsl:attribute>
        </xsl:if>

        <xsl:if test="string-length(substring-before($nmtokens, ' ')) = 0">
        <xsl:attribute name="xmi.id"><xsl:value-of select="$nmtokens" /><xsl:value-of select="$child" /></xsl:attribute>
        </xsl:if>
    
       <xsl:attribute name="isSpecification">false</xsl:attribute>

        <xsl:element name="UML:Generalization.child">
          <xsl:element name="UML:Class">
            <xsl:attribute name="xmi.idref"><xsl:value-of select="$child" /></xsl:attribute>
          </xsl:element>
        </xsl:element>

        <xsl:element name="UML:Generalization.parent">
          <xsl:element name="UML:Class">
            <xsl:if test="string-length(substring-before($nmtokens, ' ')) > 0">
            <xsl:attribute name="xmi.idref"><xsl:value-of select="substring-before($nmtokens, ' ')" /></xsl:attribute>
            </xsl:if> 
           <xsl:if test="string-length(substring-before($nmtokens, ' ')) = 0">
            <xsl:attribute name="xmi.idref"><xsl:value-of select="$nmtokens" /></xsl:attribute>
            </xsl:if> 
          </xsl:element>
        </xsl:element>
      </xsl:element>
               
      <xsl:choose>

        <xsl:when test="substring-after($nmtokens, ' ') != ''">
          <xsl:call-template name="gen_supertypes">
            <xsl:with-param name="nmtokens" select="substring-after($nmtokens, ' ')"/>
            <xsl:with-param name="child" select="$child" />
          </xsl:call-template>
        </xsl:when>
                    
        <xsl:otherwise />

      </xsl:choose>
      </xsl:if>

    </xsl:template>    

  <xsl:template name="ref_supertypes">
    <xsl:param name="nmtokens"/>
    <xsl:param name="child"/>

    <xsl:if test="string-length($nmtokens) > 0">

      <xsl:element name="UML:Generalization">

        <xsl:if test="string-length(substring-before($nmtokens, ' ')) > 0">
        <xsl:attribute name="xmi.idref"><xsl:value-of select="substring-before($nmtokens, ' ')" /><xsl:value-of select="$child" /></xsl:attribute>
        </xsl:if>

        <xsl:if test="string-length(substring-before($nmtokens, ' ')) = 0">
        <xsl:attribute name="xmi.idref"><xsl:value-of select="$nmtokens" /><xsl:value-of select="$child" /></xsl:attribute>
        </xsl:if>
    
      </xsl:element>
               
      <xsl:choose>

        <xsl:when test="substring-after($nmtokens, ' ') != ''">
          <xsl:call-template name="ref_supertypes">
            <xsl:with-param name="nmtokens" select="substring-after($nmtokens, ' ')"/>
            <xsl:with-param name="child" select="$child" />
          </xsl:call-template>
        </xsl:when>
                    
        <xsl:otherwise />

      </xsl:choose>
      </xsl:if>

    </xsl:template>    

</xsl:stylesheet>

