<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:UML="org.omg.xmi.namespace.UML">
<xsl:output method="text" encoding="UTF-8"/>

<!--

Open Source Initiative OSI - Common Public License Version 1.0

THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC 
LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM 
CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

1. DEFINITIONS 

"Contribution" means:

  a) in the case of the initial Contributor, the initial code and documentation 
  distributed under this Agreement, and
 
  b) in the case of each subsequent Contributor:

  i) changes to the Program, and

  ii) additions to the Program;

  where such changes and/or additions to the Program originate from and are 
  distributed by that particular Contributor. A Contribution 'originates' from a 
  Contributor if it was added to the Program by such Contributor itself or 
  anyone acting on such Contributor's behalf. Contributions do not include 
  additions to the Program which: (i) are separate modules of software 
  distributed in conjunction with the Program under their own license agreement, 
  and (ii) are not derivative works of the Program.

"Contributor" means any person or entity that distributes the Program. 

"Licensed Patents " mean patent claims licensable by a Contributor which are 
necessarily infringed by the use or sale of its Contribution alone or when 
combined with the Program.

"Program" means the Contributions distributed in accordance with this Agreement. 

"Recipient" means anyone who receives the Program under this Agreement, 
including all Contributors. 

2. GRANT OF RIGHTS

  a) Subject to the terms of this Agreement, each Contributor hereby grants 
  Recipient a non-exclusive, worldwide, royalty-free copyright license to 
  reproduce, prepare derivative works of, publicly display, publicly perform, 
  distribute and sublicense the Contribution of such Contributor, if any, and 
  such derivative works, in source code and object code form.

  b) Subject to the terms of this Agreement, each Contributor hereby grants 
  Recipient a non-exclusive, worldwide, royalty-free patent license under 
  Licensed Patents to make, use, sell, offer to sell, import and otherwise 
  transfer the Contribution of such Contributor, if any, in source code and 
  object code form. This patent license shall apply to the combination of the 
  Contribution and the Program if, at the time the Contribution is added by the 
  Contributor, such addition of the Contribution causes such combination to be 
  covered by the Licensed Patents. The patent license shall not apply to any 
  other combinations which include the Contribution. No hardware per se is 
  licensed hereunder.

  c) Recipient understands that although each Contributor grants the licenses to 
  its Contributions set forth herein, no assurances are provided by any 
  Contributor that the Program does not infringe the patent or other 
  intellectual property rights of any other entity. Each Contributor disclaims 
  any liability to Recipient for claims brought by any other entity based on 
  infringement of intellectual property rights or otherwise. As a condition to 
  exercising the rights and licenses granted hereunder, each Recipient hereby 
  assumes sole responsibility to secure any other intellectual property rights 
  needed, if any. For example, if a third party patent license is required to 
  allow Recipient to distribute the Program, it is Recipient's responsibility to 
  acquire that license before distributing the Program.

  d) Each Contributor represents that to its knowledge it has sufficient 
  copyright rights in its Contribution, if any, to grant the copyright license 
  set forth in this Agreement.

3. REQUIREMENTS 

A Contributor may choose to distribute the Program in object code form under its 
own license agreement, provided that: 

  a) it complies with the terms and conditions of this Agreement; and

  b) its license agreement:

  i) effectively disclaims on behalf of all Contributors all warranties and 
  conditions, express and implied, including warranties or conditions of title 
  and non-infringement, and implied warranties or conditions of merchantability 
  and fitness for a particular purpose; 

  ii) effectively excludes on behalf of all Contributors all liability for 
  damages, including direct, indirect, special, incidental and consequential 
  damages, such as lost profits; 

  iii) states that any provisions which differ from this Agreement are offered 
  by that Contributor alone and not by any other party; and 

  iv) states that source code for the Program is available from such 
  Contributor, and informs licensees how to obtain it in a reasonable manner on 
  or through a medium customarily used for software exchange. 

When the Program is made available in source code form:

  a) it must be made available under this Agreement; and

  b) a copy of this Agreement must be included with each copy of the Program. 

Contributors may not remove or alter any copyright notices contained within the 
Program.

Each Contributor must identify itself as the originator of its Contribution, if 
any, in a manner that reasonably allows subsequent Recipients to identify the 
originator of the Contribution. 

4. COMMERCIAL DISTRIBUTION 

Commercial distributors of software may accept certain responsibilities with 
respect to end users, business partners and the like. While this license is 
intended to facilitate the commercial use of the Program, the Contributor who 
includes the Program in a commercial product offering should do so in a manner 
which does not create potential liability for other Contributors. Therefore, if 
a Contributor includes the Program in a commercial product offering, such 
Contributor ("Commercial Contributor") hereby agrees to defend and indemnify 
every other Contributor ("Indemnified Contributor") against any losses, damages 
and costs (collectively "Losses") arising from claims, lawsuits and other legal 
actions brought by a third party against the Indemnified Contributor to the 
extent caused by the acts or omissions of such Commercial Contributor in 
connection with its distribution of the Program in a commercial product 
offering. The obligations in this section do not apply to any claims or Losses 
relating to any actual or alleged intellectual property infringement. In order 
to qualify, an Indemnified Contributor must: a) promptly notify the Commercial 
Contributor in writing of such claim, and b) allow the Commercial Contributor to 
control, and cooperate with the Commercial Contributor in, the defense and any 
related settlement negotiations. The Indemnified Contributor may participate in 
any such claim at its own expense. 

For example, a Contributor might include the Program in a commercial product 
offering, Product X. That Contributor is then a Commercial Contributor. If that 
Commercial Contributor then makes performance claims, or offers warranties 
related to Product X, those performance claims and warranties are such 
Commercial Contributor's responsibility alone. Under this section, the 
Commercial Contributor would have to defend claims against the other 
Contributors related to those performance claims and warranties, and if a court 
requires any other Contributor to pay any damages as a result, the Commercial 
Contributor must pay those damages. 

5. NO WARRANTY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN 
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR 
IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, 
NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each 
Recipient is solely responsible for determining the appropriateness of using and 
distributing the Program and assumes all risks associated with its exercise of 
rights under this Agreement, including but not limited to the risks and costs of 
program errors, compliance with applicable laws, damage to or loss of data, 
programs or equipment, and unavailability or interruption of operations.
 
6. DISCLAIMER OF LIABILITY 

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY 
CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST 
PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS 
GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

7. GENERAL

If any provision of this Agreement is invalid or unenforceable under applicable 
law, it shall not affect the validity or enforceability of the remainder of the 
terms of this Agreement, and without further action by the parties hereto, such 
provision shall be reformed to the minimum extent necessary to make such 
provision valid and enforceable. 

If Recipient institutes patent litigation against a Contributor with respect to 
a patent applicable to software (including a cross-claim or counterclaim in a 
lawsuit), then any patent licenses granted by that Contributor to such Recipient 
under this Agreement shall terminate as of the date such litigation is filed. In 
addition, if Recipient institutes patent litigation against any entity 
(including a cross-claim or counterclaim in a lawsuit) alleging that the Program 
itself (excluding combinations of the Program with other software or hardware) 
infringes such Recipient's patent(s), then such Recipient's rights granted under 
Section 2(b) shall terminate as of the date such litigation is filed.

All Recipient's rights under this Agreement shall terminate if it fails to 
comply with any of the material terms or conditions of this Agreement and does 
not cure such failure in a reasonable period of time after becoming aware of 
such noncompliance. If all Recipient's rights under this Agreement terminate, 
Recipient agrees to cease use and distribution of the Program as soon as 
reasonably practicable. However, Recipient's obligations under this Agreement 
and any licenses granted by Recipient relating to the Program shall continue and 
survive. 

Everyone is permitted to copy and distribute copies of this Agreement, but in 
order to avoid inconsistency the Agreement is copyrighted and may only be 
modified in the following manner. The Agreement Steward reserves the right to 
publish new versions (including revisions) of this Agreement from time to time. 
No one other than the Agreement Steward has the right to modify this Agreement. 
IBM is the initial Agreement Steward. IBM may assign the responsibility to serve 
as the Agreement Steward to a suitable separate entity. Each new version of the 
Agreement will be given a distinguishing version number. The Program (including 
Contributions) may always be distributed subject to the version of the Agreement 
under which it was received. In addition, after a new version of the Agreement 
is published, Contributor may elect to distribute the Program (including its 
Contributions) under the new version. Except as expressly stated in Sections 
2(a) and 2(b) above, Recipient receives no rights or licenses to the 
intellectual property of any Contributor under this Agreement, whether 
expressly, by implication, estoppel or otherwise. All rights in the Program not 
expressly granted under this Agreement are reserved. 

This Agreement is governed by the laws of the State of New York and the 
intellectual property laws of the United States of America. No party to this 
Agreement will bring a legal action under this Agreement more than one year 
after the cause of action arose. Each party waives its rights to a jury trial in 
any resulting litigation.

-->


<!-- UML-to-EXPRESS Stylesheet Release 0.1 June 2003
     This stylesheet reads an XMI 1.2 file containing a UML 1.4 model and generates the equivalent EXPRESS schema.
     The XMI files used are the native format used by the free tool PoseidonCE. This stylesheet has not been
     tested against any other XMI files. The PoseidonCE XMI files do validate using the UML 1.4 DTD.
     Add DOCTYPE to the XMI file because the XPath id() function is used : <!DOCTYPE XMI SYSTEM "01-02-16.dtd">

      Currently only the following are supported:
      UML Package -> SCHEMA
      UML Class -> ENTITY
      UML Abstract Class -> ABSTRACT SUPERTYPE, no other SUPERTYPE constraint created
      UML Generalization -> SUBTYPE OF, Multiple inheritance is supported
      UML Association between Classes -> explicit attribute in two cases 
          1 - one end name = association name > explicit attribute at end with no, or different name
          2 - existence dependence -> explicit attribute at end with dependency (i.e. lower bound is 0)
              (Assoc End 1 lower bound zero and Assoc End 2 lower bound not zero means Class 1 depends on Class 2)
          - SET is created for upper bound > 1
          - if multiplicity is 0..1 then OPTIONAL is included
          - if both association end lower bounds are 0 nothing is created except as in 1 above
            ( this is because cannot tell which entity should own the attribute )
          - if both association end lower bounds are not zero nothing is created except as in 1 above
          - no inverses are created
      UML Attribute (single valued) -> explicit attribute, multiplicity lower bound 0 -> OPTIONAL
      UML string and UML Class string -> STRING simple type
      UML boolean and UML Class boolean -> BOOLEAN simple type
      UML int and UML Class integer -> INTEGER simple type
      UML Class real -> REAL simple type

-->



<xsl:template match="/">


  <xsl:text>SCHEMA </xsl:text>
  <xsl:value-of select="//UML:Package/@name"/>
  <xsl:text>;&#10;  </xsl:text>


  <xsl:for-each select="//UML:Namespace.ownedElement/UML:Class">
  <xsl:sort select="@name"/>

    <!-- set entity name from class name -->
    <xsl:choose>

    <!-- Don't write classes that have same name as EXPRESS/UML datatypes -->
    <xsl:when test="'string'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
    <xsl:when test="'real'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
    <xsl:when test="'integer'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
    <xsl:when test="'boolean'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
    <xsl:when test="'binary'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
    <xsl:when test="'logical'=translate(@name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>

    <xsl:otherwise>
    <xsl:text>&#10;  ENTITY </xsl:text>
    <xsl:value-of select="@name"/>

    <!-- make abstract class abstract supertype -->

    <xsl:if test="@isAbstract='true'">
      <xsl:text> ABSTRACT SUPERTYPE</xsl:text>
    </xsl:if>

    <!-- if the generalization element is found, then add subtype decl -->

    <xsl:for-each select="UML:GeneralizableElement.generalization">
      <xsl:text> SUBTYPE OF ( </xsl:text>

 
    </xsl:for-each>

    <xsl:for-each select="UML:GeneralizableElement.generalization/UML:Generalization"> 
      <xsl:call-template name="get_entity_parent">
        <xsl:with-param name="gen_id"><xsl:value-of select="@xmi.idref"/></xsl:with-param>
      </xsl:call-template>

      <!-- if not last supertype write comma, if last write close paren -->

      <xsl:if test="last()=position()">
        <xsl:text> ) </xsl:text>
      </xsl:if>
      <xsl:if test="last()!=position()">
        <xsl:text> , </xsl:text>
      </xsl:if>
    </xsl:for-each>

    <xsl:text>;&#10;</xsl:text>

    <!-- handle explicit attributes with simple domains -->

    <xsl:for-each select="UML:Classifier.feature/UML:Attribute">
      <xsl:text>    </xsl:text>
      <xsl:value-of select="@name"/>
      <xsl:text> : </xsl:text>

      <!-- if lower bound is 0 then domain is optional -->
      <xsl:if test="UML:StructuralFeature.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0'">
        <xsl:text>OPTIONAL </xsl:text>
      </xsl:if>

      <xsl:for-each select="UML:StructuralFeature.type/UML:Class"> 
        <xsl:call-template name="get_attribute_domain">
          <xsl:with-param name="clasf_id"><xsl:value-of select="@xmi.idref"/></xsl:with-param>
        </xsl:call-template>

      </xsl:for-each>

      <xsl:for-each select="UML:StructuralFeature.type/UML:DataType"> 
        <xsl:call-template name="get_attribute_domain">
          <xsl:with-param name="clasf_id"><xsl:value-of select="@xmi.idref"/></xsl:with-param>
        </xsl:call-template>

      </xsl:for-each>



   </xsl:for-each>

   <!-- handle associations where class end is 0,-1 or 0,1 and other class end is 1,1 -->

      <xsl:call-template name="get_owned_assoc">
        <xsl:with-param name="clas_id"><xsl:value-of select="@xmi.id"/></xsl:with-param>
      </xsl:call-template>


    <xsl:text>  END_ENTITY;&#10;  </xsl:text>
    </xsl:otherwise>
  </xsl:choose>

  </xsl:for-each>

  <xsl:text>&#10; END_SCHEMA;</xsl:text>

</xsl:template>

<!-- given id of generalization element, find id of parent class and call get_entity_name -->

<xsl:template name="get_entity_parent">

  <xsl:param name="gen_id"/>

  <xsl:for-each select="//UML:Namespace.ownedElement/UML:Generalization"> 

    <xsl:if test="@xmi.id=$gen_id">
      <xsl:call-template name="get_entity_name">
        <xsl:with-param name="ent_id"><xsl:value-of select="UML:Generalization.parent/UML:Class/@xmi.idref"/></xsl:with-param>
      </xsl:call-template>

    </xsl:if>

  </xsl:for-each>

</xsl:template>

<!-- given id of class element, get name -->

<xsl:template name="get_entity_name">

  <xsl:param name="ent_id"/>

  <xsl:for-each select="//UML:Class"> 

  <xsl:if test="@xmi.id=$ent_id">
    <xsl:value-of select="@name"/>
  </xsl:if>

  </xsl:for-each>

</xsl:template>

<!-- given id of datatype, find the name -->

<xsl:template name="get_attribute_domain">

  <xsl:param name="clasf_id"/>

  <xsl:for-each select="//UML:DataType"> 

    <xsl:if test="@xmi.id=$clasf_id">

      <xsl:choose>

      <xsl:when test="@name='int'">
        <xsl:text>INTEGER ;&#10;</xsl:text>
      </xsl:when>

      <xsl:when test="@name='boolean'">
        <xsl:text>BOOLEAN ;&#10;</xsl:text>
      </xsl:when>

      <xsl:when test="@name='string'">
        <xsl:text>STRING ;&#10;</xsl:text>
      </xsl:when>

      </xsl:choose>
    </xsl:if>

  </xsl:for-each>

  <xsl:for-each select="//UML:Class"> 

    <xsl:if test="@xmi.id=$clasf_id">
      <xsl:value-of select="@name"/>
      <xsl:text> ;&#10;</xsl:text>
    </xsl:if>

  </xsl:for-each>


</xsl:template>

<!-- given id of class id, find owned associations -->

<xsl:template name="get_owned_assoc">

<xsl:param name="clas_id"/>

  <xsl:for-each select="//UML:Association">

    <xsl:for-each select="UML:Association.connection/UML:AssociationEnd">

      <!-- check if association end points to the class -->    
      <xsl:if test="UML:AssociationEnd.participant/UML:Class/@xmi.idref=$clas_id">

         <xsl:choose>
          <!-- if this is the first association end -->
          <xsl:when test="position()='1'">
              <xsl:choose>

               <!-- if name of other end is same as association name -->
              <xsl:when test="../child::UML:AssociationEnd[position()=2]/@name=../../@name">

                  <!-- then class specified does own association so write association name and colon -->
                  <xsl:text>   </xsl:text><xsl:value-of select="../../@name"/><xsl:text> : </xsl:text>

                    <!-- if upper bound on other end is not 1 then domain is a set -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1'">

                      <xsl:text>SET [</xsl:text>
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:text>:</xsl:text>
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1'">
                      <xsl:text>?</xsl:text>
                      </xsl:if>
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1'">
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>

                      </xsl:if>

                      <xsl:text>] OF </xsl:text>

                    </xsl:if>

                    <!-- if upper bound on other end is 1 and lower bound is 0 then domain is optional -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1'">
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0'">
                      <xsl:text>OPTIONAL </xsl:text>
                      </xsl:if>
                    </xsl:if>


                   <!-- write name of class on other end of association as domain of attribute -->
                   <xsl:call-template name="get_entity_name">
                   <xsl:with-param name="ent_id"><xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.participant/UML:Class/@xmi.idref"/></xsl:with-param>
                   </xsl:call-template>
                   <xsl:text> ;&#10;</xsl:text>
       
                 </xsl:when>

              <!-- if lower bound on other end is not zero (1 or more) -->
              <!-- and lower bound on this end is zero (bound may be contained or referenced) -->

              <xsl:when test="(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower!='0' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower!='0')
                             and 
                            (UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0')">

                  <!-- then class specified does own association so write association name and colon -->
                  <xsl:text>    </xsl:text><xsl:value-of select="../../@name"/><xsl:text> : </xsl:text>

                    <!-- if upper bound on other end is not 1 then domain is a set -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1'">

                      <xsl:text>SET [</xsl:text>
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:text>:</xsl:text>
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1'">
                      <xsl:text>?</xsl:text>
                      </xsl:if>
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1'">
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>

                      </xsl:if>

                      <xsl:text>] OF </xsl:text>

                    </xsl:if>

                    <!-- if upper bound on other end is 1 and lower bound is 0 then domain is optional -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1'">
                      <xsl:if test="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0'">
                      <xsl:text>OPTIONAL </xsl:text>
                      </xsl:if>
                    </xsl:if>


                   <!-- write name of class on other end of association as domain of attribute -->
                   <xsl:call-template name="get_entity_name">
                   <xsl:with-param name="ent_id"><xsl:value-of select="../child::UML:AssociationEnd[position()=2]/UML:AssociationEnd.participant/UML:Class/@xmi.idref"/></xsl:with-param>
                   </xsl:call-template>
                   <xsl:text> ;&#10;</xsl:text>
       
                 </xsl:when>
                </xsl:choose>
             </xsl:when>

          <!-- perform exactly the same process the assoc end is the second one -->
          <xsl:when test="position()='2'">
              <xsl:choose>
              <xsl:when test="../child::UML:AssociationEnd[position()=1]/@name=../../@name">

                <xsl:text>    </xsl:text><xsl:value-of select="../../@name"/><xsl:text> : </xsl:text>
                <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1'">


                      <xsl:text>SET [</xsl:text>
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:text>:</xsl:text>
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1'">
                      <xsl:text>?</xsl:text>
                      </xsl:if>
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1'">
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                      </xsl:if>

                      <xsl:text>] OF </xsl:text>
                </xsl:if>

                    <!-- if upper bound on other end is 1 and lower bound is 0 then domain is optional -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1'">
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0'">
                      <xsl:text>OPTIONAL </xsl:text>
                      </xsl:if>
                    </xsl:if>


                <xsl:call-template name="get_entity_name">
                  <xsl:with-param name="ent_id"><xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.participant/UML:Class/@xmi.idref"/></xsl:with-param>
                </xsl:call-template>
                <xsl:text> ;&#10;</xsl:text> 
              </xsl:when>


            <xsl:when test="(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower!='0' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower!='0')
                          and 
                          (UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0')">
       

                <xsl:text>    </xsl:text><xsl:value-of select="../../@name"/><xsl:text> : </xsl:text>
                <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='1'">

                      <xsl:text>SET [</xsl:text>
                      <xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:value-of select="id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower"/>
                      <xsl:text>:</xsl:text>
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='-1'">
                      <xsl:text>?</xsl:text>
                      </xsl:if>
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper!='-1'">
                        <xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                        <xsl:value-of select="id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper"/>
                      </xsl:if>

                      <xsl:text>] OF </xsl:text>

                </xsl:if>

                    <!-- if upper bound on other end is 1 and lower bound is 0 then domain is optional -->
                    <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@upper='1'">
                      <xsl:if test="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0' or id(../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.multiplicity/UML:Multiplicity/@xmi.idref)/UML:Multiplicity.range/UML:MultiplicityRange/@lower='0'">
                      <xsl:text>OPTIONAL </xsl:text>
                      </xsl:if>
                    </xsl:if>

                <xsl:call-template name="get_entity_name">
                  <xsl:with-param name="ent_id"><xsl:value-of select="../child::UML:AssociationEnd[position()=1]/UML:AssociationEnd.participant/UML:Class/@xmi.idref"/></xsl:with-param>
                </xsl:call-template>
                <xsl:text> ;&#10;</xsl:text> 
              </xsl:when>
              </xsl:choose>

          </xsl:when>
       </xsl:choose>
          
      </xsl:if>
    </xsl:for-each>  
  </xsl:for-each>

</xsl:template>

</xsl:stylesheet>